/*
 * This file is a part of Winix
 * and is distributed under the 2-Clause BSD licence.
 * Author: Tomasz Sowa <t.sowa@ttmath.org>
 */

/* 
 * Copyright (c) 2010-2014, Tomasz Sowa
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 * 
 */

#ifndef headerfile_winix_db_dbitemcolumns
#define headerfile_winix_db_dbitemcolumns

#include <libpq-fe.h>
#include "core/item.h"
#include "dbbase.h"


namespace Winix
{



struct DbItemColumns
{
	int id;
	int user_id;
	int group_id;
	int privileges;
	int date_creation;
	int date_modification;
	int url;
	int type;
	int parent_id;
	int content_id;
	int link_to;
	int link_redirect;
	int subject;
	int content;
	int content_type;
	int guest_name;
	int modification_user_id;
	int html_template;
	int file_path;
	int file_fs;
	int file_type;
	int has_thumb;
	int hash;
	int hash_type;
	int file_size;
	int ref;
	int modify_index;
	int sort_index;
	int meta;
	int ameta;

	DbItemColumns(DbBase & db_base_) : db_base(db_base_)
	{
	}

	void SetColumns(PGresult * r);
	void SetItem(PGresult * r, long row, Item & item);

private:

	DbBase & db_base;

};



} // namespace Winix



#endif

